BoE/BoE.WebSite/Areas/Admin/Controllers/StatsController.cs
using BoE.Contexts;
using BoE.Models;
using BoE.WebSite.Areas.Admin.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace BoE.WebSite.Areas.Admin.Controllers
{
    public class StatsController : Controller
    {
        BoEContext db = new BoEContext();

        [HttpGet]
        public ActionResult Index()
        {
            return View();
        }

        private void UpKeepDifferencesViewBag()
        {
            ViewBag.Characters = db.Characters.Select(c => new
            {
                Name = c.Name,
                CharacterId = c.CharacterId
            }).OrderBy(c => c.Name);
        }
        [HttpGet]
        public ActionResult UpKeepDifferences()
        {
            UpKeepDifferencesViewBag();
            return View();
        }

        [HttpPost]
        public ActionResult UpKeepDifferences(UpKeepDifferencesModel model)
        {
            if (ModelState.IsValid)
            {
                List<int> uniqueIds = db.Users.Select(u => new
                {
                    UserId=u.UserId,
                    UniqueId=u.UniqueId
                }).Where(u => model.CharactersId.Contains(u.UserId))
                .Select(c => c.UniqueId.Value).ToList();
                Dictionary<int, List<KeyValuePair<int, int>>> upKeepsRecords = new Dictionary<int,List<KeyValuePair<int,int>>>();
                foreach (int uniqueId in uniqueIds)
                    upKeepsRecords.Add(uniqueId, new List<KeyValuePair<int, int>>());

                foreach(HttpPostedFileBase file in model.Files)
                {
                    StreamReader reader = new StreamReader(file.InputStream);
                    string line;
                    while ((line = reader.ReadLine()) != null)
                    {
                        if (line.Contains("Upkeep?usages="))
                        {
                            foreach (var upKeepsRecord in upKeepsRecords)
                            {
                                List<KeyValuePair<int, int>> usageRecords = GetUpKeepRecordFromLine(upKeepsRecord.Key, line);
                                if (usageRecords != null)
                                    upKeepsRecord.Value.AddRange(usageRecords);
                            }
                        }
                    }
                }
                List<UpKeepDifferencesReportModel> reports = new List<UpKeepDifferencesReportModel>();
                foreach (var upKeepsRecord in upKeepsRecords)
                {
                    int userId = db.Users.First(u => u.UniqueId == upKeepsRecord.Key).UserId;
                    UpKeepDifferencesReportModel report = new UpKeepDifferencesReportModel() 
                    { 
                        CharacterName=db.Characters.Select(c => new 
                        { 
                            Name=c.Name, 
                            CharacterId=c.CharacterId 
                        }).First(c => c.CharacterId == userId).Name,
                        UniqueId = upKeepsRecord.Key
                    };
                    foreach (var itemRecord in upKeepsRecord.Value)
                    {
                        int gameId = itemRecord.Key;
                        int usage = itemRecord.Value;
                        ItemUsageModel itemUsage = report.ItemUsages.FirstOrDefault(ig => ig.GameId == gameId);
                        if (itemUsage == null)
                        {
                            var items = db.Items.Select(it => new
                                {
                                    Name = it.Name,
                                    GameId = it.GameId
                                }).Where(it => it.GameId == gameId || it.GameId == gameId + 1 || it.GameId == gameId - 1)
                                .Select(it => it.Name).AsEnumerable();
                            itemUsage = new ItemUsageModel()
                            {
                                GameId = gameId,
                                TotalUsage = usage,
                                ItemName = items.Count() != 0 ? items.Aggregate((a, b) => a + " or " + b) : "Unknown"
                            };
                            report.ItemUsages.Add(itemUsage);
                        }
                        else
                        {
                            itemUsage.NumberOfUse++;
                            itemUsage.TotalUsage += usage;
                        }
                    }
                    reports.Add(report);
                }
                return View("UpKeepDifferencesReport", reports);
            }
            UpKeepDifferencesViewBag();
            return View(model);
        }
        private List<KeyValuePair<int, int>> GetUpKeepRecordFromLine(int uniqueId, string line)
        {
            string records = line.Substring(line.IndexOf("usages=") + "usages=".Length);
            records = records.Substring(0, records.IndexOf("&token"));
            IEnumerable<string> usages = records.Split(new string[] { "]," }, StringSplitOptions.None).Select(r => r.Replace("[", "").Replace("]",""));
            foreach (string usage in usages)
            {
                List<KeyValuePair<int, int>> usageRecords = null;
                IEnumerable<int> itemUsages = usage.Split(',').Select(iu => int.Parse(iu));
                if (itemUsages.ElementAt(0) == uniqueId)
                {
                    if (usageRecords == null)
                        usageRecords = new List<KeyValuePair<int, int>>();
                    for (int i = 3; i < itemUsages.Count(); i+=2)
                        usageRecords.Add(new KeyValuePair<int, int>(itemUsages.ElementAt(i), itemUsages.ElementAt(i + 1)));
                }
                return usageRecords;
            }

            return null;
        }
    }
}

BoE/BoE.WebSite/Areas/Admin/Views/Stats/Index.cshtml
@{
    ViewBag.Title = "Index";
}

<h2>Index</h2>

<p>
    @Html.ActionLink("Check upkeep differences", "UpKeepDifferences")
</p>

BoE/BoE.WebSite/Areas/Admin/Views/Stats/UpKeepDifferences.cshtml
@model BoE.WebSite.Areas.Admin.Models.UpKeepDifferencesModel
@{
    ViewBag.Title = "Admin | UpKeep Differences";
}

<h2>UpKeep Differences</h2>

@using (Html.BeginForm("UpKeepDifferences", "Stats", FormMethod.Post, new { enctype = "multipart/form-data" }))
{ 
    @Html.ValidationSummary(true)
    <fieldset>
        <legend>Check UpKeep Diferences</legend>
        <p> 
            Will list the difference between the game server and user upkeep.
        </p>
        <div>
            @Html.LabelFor(m => m.CharactersId)
            @Html.DropDownListFor(m => m.CharactersId, new SelectList(ViewBag.Characters, "CharacterId", "Name"), "--select--", new { @class="select-2", multiple="" })
        </div>
        <div>
            @Html.LabelFor(m => m.Files)
            @Html.TextBoxFor(m => m.Files, new { type="file", multiple="" })
        </div>
@*        <div>
            @Html.LabelFor(m => m.StartDate)
            @Html.TextBoxFor(m => m.StartDate, new { type="date" });
        </div>*@
        <div>
            <input type="submit" value="Check" />
        </div>
    </fieldset>
}

<p>
    @Html.ActionLink("Go back", "Index")
</p>

BoE/BoE.WebSite/Areas/Admin/Views/Stats/UpKeepDifferencesReport.cshtml
@model IEnumerable<BoE.WebSite.Areas.Admin.Models.UpKeepDifferencesReportModel>
@{
    ViewBag.Title = "UpKeepDifferencesReport";
}

<h2>UpKeep Differences Report</h2>

@foreach (var report in Model)
{
    <h3>@report.CharacterName (@report.UniqueId)</h3>
    foreach (var item in report.ItemUsages)
    {
        <div style="margin: 20px;">
            <div>
                <label>GamId: </label>
                <span>@item.GameId</span>
            </div>
            <div>
                <label>Item: </label>
                <span>@item.ItemName</span>
            </div>
            <div>
                <label>Number of use: </label>
                <span>@item.NumberOfUse</span>
            </div>
            <div>
                <label>Total usage: </label>
                <span>@item.TotalUsage</span>
            </div>
        </div>
    }
}